/* This file is part of "Heuristics for SONET network design".
   See COPYRIGHT and LICENSE files for details.

   This file, as the whole "Heuristics for SONET network design"
   package, is released under the GNU GPL License.  
   Copyright (C) Pierre Lemaire, 2001.
*/

#include <time.h>
#include <stdlib.h>
#include <stdio.h>
#include "edge.hpp"

int main(void)
{ int i,j,k;
  int n;
  Edge *edge, *tmp;

  srand(time(0)); // initialisation du generateur aleatoire

  // reads 1 edge so as to initialize the loop.
  if (scanf("%d:%d,%d\n", &i,&j,&k) > 0) edge = new Edge(i,j,k);
  else return 0;
  edge->succ = edge; n = 1;
  
  // reads what's after
  while(scanf("%d:%d,%d\n", &i,&j,&k) > 0)
  { tmp = new Edge(i,j,k); n++;
    k = rand() % n;
    while(k >= 0){ edge = edge->succ; k--; }
    tmp->succ = edge->succ;
    edge->succ = tmp;
    }

  // writes the loop of edges on stdout
  tmp = edge;
  do
  { cout << tmp->node[0] << ":" << tmp->node[1] << "," << tmp->demand << endl;
    tmp = tmp->succ;
    }while(tmp != edge);




  return 0;
  }
