/* This file is part of "Heuristics for SONET network design".
   See COPYRIGHT and LICENSE files for details.

   This file, as the whole "Heuristics for SONET network design"
   package, is released under the GNU GPL License.  
   Copyright (C) Pierre Lemaire, 2001.
*/

#include <time.h>
#include <stdlib.h>
#include <iostream.h>

int main(int argc, char * argv[])
{ int n = -1; 
  int p = -1; 
  int d = 1;
  
  // --------------------------------------------------------------------------
  // gets parameters
  --argc; ++argv;
  while (argc >= 1)
  { if (strcmp(*argv,"-h") == 0)
    { cout << "--------------------------------------" << endl
           << "usage: grid [options]" << endl
           << "  -h         : this help" << endl
           << "  -n int     : number of lines" << endl
           << "  -p int     : number of columns" << endl
           << "  -d int     : maximum value of a demand" << endl;
      }
    else if (strcmp(*argv, "-n")==0)
    { --argc; ++argv;
      if (argc <= 0){ cerr << "option -n requires a value" << endl; exit(1); }
      n = atoi(*argv);
      }
    else if (strcmp(*argv, "-p")==0)
    { --argc; ++argv;
      if (argc <= 0){ cerr << "option -p requires a value" << endl; exit(1); }
      p = atoi(*argv);
      }
    else if (strcmp(*argv, "-d")==0)
    { --argc; ++argv;
      if (argc <= 0){ cerr << "option -d requires a value" << endl; exit(1); }
      d = atoi(*argv);
      }
    else
    { cerr << "unknown option: " << *argv << endl;
      }
    --argc; ++argv;
    }
  // --------------------------------------------------------------------------
  if (n < 1)
  { cerr << "Number of lines (n) must be a positive integer" << endl;
    exit(1);
    }
  if (p < 1)
  { cerr << "Number of columns (p) must be a positive integer" << endl;
    exit(1);
    }
  if (d < 1)
  { cerr << "Maximum demand (d) must be a positive integer" << endl;
    exit(1);
    }
  // --------------------------------------------------------------------------
  int i,j;
  srand(time(0));

  // horizontales
  for(i=1; i<=p; i++) for (j=1; j<n; j++)
    cout << ((i-1)*n+j) << ":" << ((i-1)*n+j+1)
         << "," << (rand() % d +1) << endl;
  // verticales
  for(i=1; i<p; i++) for (j=1; j<=n; j++)
    cout << ((i-1)*n+j) << ":" << ((i*n+j))
         << "," << (rand() % d +1) << endl;

  return 0;
  }
